#include "undelete_drv.h"
//#define SERVICE_ID	0x03E
#define SERVICE_ID  0x74

NTSTATUS Driver_IoCtl(IN PDEVICE_OBJECT fdo, IN PIRP Irp);
NTSTATUS CreateDevice(IN PDEVICE_OBJECT fdo, IN PIRP Irp);
NTSTATUS CloseDevice(IN PDEVICE_OBJECT fdo, IN PIRP Irp);
VOID Driver_UnLoad(IN PDRIVER_OBJECT pDriverObject);


//****************************************************************
//   NtDeleteFile
//
//
// 
//
//***************************************************************
/*
NTSTATUS MyNtDeleteFileProc(IN  PUNICODE_STRING FileName)
{
 DbgPrint("MyNtDeleteFileProc %ws",FileName);
 return STATUS_ACCESS_DENIED;
}
*/
typedef NTSTATUS
  (*NtOpenFile_PTR)(
    OUT PHANDLE  FileHandle,
    IN ACCESS_MASK  DesiredAccess,
    IN POBJECT_ATTRIBUTES  ObjectAttributes,
    OUT PIO_STATUS_BLOCK  IoStatusBlock,
    IN ULONG  ShareAccess,
    IN ULONG  OpenOptions
    );

NtOpenFile_PTR OldNtOpenFile;

NTSTATUS NewNtOpenFile(
    OUT PHANDLE  FileHandle,
    IN ACCESS_MASK  DesiredAccess,
    IN POBJECT_ATTRIBUTES  ObjectAttributes,
    OUT PIO_STATUS_BLOCK  IoStatusBlock,
    IN ULONG  ShareAccess,
    IN ULONG  OpenOptions)
{
	if (DesiredAccess & DELETE) {
		PWCHAR wcsFileName = ObjectAttributes->ObjectName->Buffer; //(PWCHAR)IoStatusBlock->Pointer + 4;

		if (!wcscmp(wcsFileName, L"calc.exe"))
			return STATUS_ACCESS_DENIED;

		DbgPrint("UnDelete_Drv (NewNtOpenFile) : %ws", wcsFileName);
	}

	if (OldNtOpenFile != NULL)
		return OldNtOpenFile(
			FileHandle, DesiredAccess, ObjectAttributes, IoStatusBlock,
            ShareAccess, OpenOptions);

	return STATUS_ACCESS_DENIED;
}

//****************************************************************
//    
//
//
//   .
//
//***************************************************************
NTSTATUS
DriverEntry (
    IN  PDRIVER_OBJECT  DriverObject,
    IN  PUNICODE_STRING RegistryPath
    )
{
    ULONG CR0Reg;
    //   
    ULONG i;
    //        
    UNICODE_STRING devName,symLink;
    //   
    PDEVICE_OBJECT fdo;
    //  
    NTSTATUS status=STATUS_SUCCESS;
    //     
    PDRV_EXTENSION dx;

    DbgPrint("Driver_Entry\n");

	OldNtOpenFile = NULL;

    //    ( )
    for (i = 0; i <= IRP_MJ_MAXIMUM_FUNCTION; i++) {
        DriverObject->MajorFunction[i] = NULL;
    }

    //
    // 
    DriverObject->MajorFunction [IRP_MJ_CREATE] =         CreateDevice;
    // 
    DriverObject->MajorFunction [IRP_MJ_CLOSE]  =         CloseDevice;
    //  
    DriverObject->MajorFunction [IRP_MJ_DEVICE_CONTROL] = Driver_IoCtl;
    // 
    DriverObject->DriverUnload = Driver_UnLoad;


    //    
    RtlInitUnicodeString(&devName,L"\\Device\\SysMan");



    //  ""
    status=IoCreateDevice(DriverObject,sizeof(struct _DRV_EXTENSION),&devName,FILE_DEVICE_UNKNOWN,0,TRUE,&fdo);
    if(!NT_SUCCESS(status))
    {
        DbgPrint("IoCreateDevice ERROR\n");
        return status;
    }

    //     
    dx=(PDRV_EXTENSION)fdo->DeviceExtension;
    dx->fdo=fdo;

    DbgPrint("SysMan FDO %X, DevExt=%X.\n",fdo,dx);

    //  ,    USER 
    RtlInitUnicodeString(&symLink,L"\\DosDevices\\SysMan");

    dx->SymLinkName=symLink;
    dx->OrigFunc=NTCALL(SERVICE_ID);
    OldNtOpenFile=dx->OrigFunc;

    DbgPrint("OldNtOpenFile=%X.\n", OldNtOpenFile);

    //  
    status=IoCreateSymbolicLink(&symLink,&devName);
    if(!NT_SUCCESS(status))
    {
        IoDeleteDevice(fdo);
        DbgPrint("IoCreateSymbolicLink ERROR\n");
        return status;
    }


    __asm
    {
	cli                     //  
	mov eax, cr0
	mov CR0Reg,eax
	and eax,0xFFFEFFFF		//  WP bit
	mov cr0, eax
    }

    DbgPrint("SetUp NewNtSetInformationFile");
//    NTCALL(SERVICE_ID)=MyNtDeleteFileProc;
	NTCALL(SERVICE_ID)=NewNtOpenFile;
    __asm
    {
 	mov eax, CR0Reg    
	mov cr0, eax            //   CR0
	sti                     //  
    }

    return status;
}

//****************************************************************
//    
//
//
//
//
//***************************************************************
NTSTATUS CompliteIrp(PIRP Irp,NTSTATUS status,ULONG info)
{
    //  
    Irp->IoStatus.Status = status;
    // 
    Irp->IoStatus.Information=info;
    //   
    IoCompleteRequest(Irp,IO_NO_INCREMENT);
    // 
    return status;
}
//****************************************************************
//      
//
//
//
//
//****************************************************************
NTSTATUS CreateDevice(IN PDEVICE_OBJECT fdo, IN PIRP Irp)
{
 DbgPrint("Device opned");
 //  
 return CompliteIrp(Irp,STATUS_SUCCESS,0);
}
NTSTATUS CloseDevice(IN PDEVICE_OBJECT fdo, IN PIRP Irp)
{
 DbgPrint("Device closed");
 //  
 return CompliteIrp(Irp,STATUS_SUCCESS,0);
}
//****************************************************************
//    
//
//
//
//
//***************************************************************
NTSTATUS Driver_IoCtl(IN PDEVICE_OBJECT fdo, IN PIRP Irp)
{
  NTSTATUS status               =STATUS_SUCCESS;
  PIO_STACK_LOCATION IrpStack   =IoGetCurrentIrpStackLocation(Irp);
  PDRV_EXTENSION dx             =(PDRV_EXTENSION)fdo->DeviceExtension;
  ULONG ControlCode             =IrpStack->Parameters.DeviceIoControl.IoControlCode;
  ULONG method                  =ControlCode&0x03;


    DbgPrint("Driver_IoCTL\n");

    switch(ControlCode)
    {
      case IOCTL_INIT_DRV:
      {
       break;
      }
    }
    
    CompliteIrp(Irp,status,0);

    return status;

// IoDeleteDevice()
}

//****************************************************************
//      
//
//
//
//
//***************************************************************
VOID Driver_UnLoad(IN PDRIVER_OBJECT DriverObject)
{
   PDRV_EXTENSION dx=(PDRV_EXTENSION)DriverObject->DeviceObject->DeviceExtension;
   ULONG CR0Reg;

    __asm
    {
	cli;
	mov eax, cr0
	mov CR0Reg,eax
	and eax,0xFFFEFFFF		//  WP bit
	mov cr0, eax
    }
    NTCALL(SERVICE_ID)=dx->OrigFunc;
    __asm
    {
 	mov eax, CR0Reg    
	mov cr0, eax            //   CR0
	sti;
    }
   // 
   IoDeleteSymbolicLink(&dx->SymLinkName);
   // 
   IoDeleteDevice(dx->fdo);
   DbgPrint("Driver_UnLoad\n");
}